% La fonction "MC_IC" fait le même travail que "MC_simple", mais en
% affichant aussi l'intervalle de confiance à 98 %.
function MC_IC
N = 5000000;
% J'appelle "pvaleur" ne niveau de risque accepté, soit 2 % ici.
pvaleur = .02;
total = 0;
% Il faut aussi calculer le total des carrés de la quantité simulée, noté
% "total_carres".
total_carres = 0;
for i = 1:N
    X = simulation ();
    f = X ^ 4;
    total = total + f;
    % Il faut mettre à jour non seulement "total", mais aussi
    % "total_carres". Notez qu'on utilise les mêmes simulations pour
    % estimer E(f) et E(f^2), d'où un gain de temps.
    total_carres = total_carres + f * f;
end
moyenne = total / N;
% "moyenne_carres" est un estimateur (de Monte-Carlo) de E(f^2).
moyenne_carres = total_carres / N;
% "variance_f" est par conséquent un estimateur de Var(f). On notera
% qu'avec notre méthode cette variance n'est autre que la variance
% empirique des réalisation de f, et qu'elle est donc automatiquement
% positive.
variance_f = moyenne_carres - moyenne * moyenne;
% "ectype_estimateur" est l'écart-type (estimé) de l'estimateur de
% Monte-Carlo.
ectype_estimateur = sqrt (variance_f / N);
% On calcule la constante "c" telle que la loi normale ait une probabilité
% (1-pvaleur) de tomber dans [±c]. Par symétrie c'est la valeur telle que
% P(N<c)=1-pvaleur/2.
c = sqrt (2) * erfinv (1 - pvaleur);
% On affiche le résultat. Noter qu'il faut utiliser la séquence ‘%%’ pour
% afficher le caractère ‘%’.
fprintf ('Au risque asymptotique %f %%, E(X^4) vaut ', 100 * pvaleur);
fprintf ('%f ± %f.\n', moyenne, c * ectype_estimateur);
% Fin du programme.
return
end
