% La fonction "MC_IC_parallele" fait le même travail que "MC_IC", mais en
% se laissant le choix de la graine aléatoire afin que le calcul soit
% indépendant de celui des autres machines ; et en affichant les données
% sous la forme qui permet de les mettre en commun ensuite.
function MC_IC_parallele
% Il faut que chaque exécutant du programme fixe sa graine aléatoire
% différemment. Ici on va dire qu'on m'a assigné la graine 14.
rng (14);
% Nombre de simulations donnant un temps de calcul de 2 minutes environ
% (sur ma machine), extrapolé à partir des résultats de la question 5.
N = 8000000;
total = 0;
total_carres = 0;
for i = 1:N
    X = simulation ();
    f = X ^ 4;
    total = total + f;
    total_carres = total_carres + f * f;
end
moyenne = total / N;
moyenne_carres = total_carres / N;
variance_f = moyenne_carres - moyenne * moyenne;
% On affiche l'estimateur, avec une haute précision (le code de format
% ‘%.15f’ signifie qu'on va afficher 15 chiffres après la virgule). Noter
% que pour afficher ‘'’, il faut écrire “''”, car sinon Matlab croira qu'on
% indique la fin de la chaine de caractères.
fprintf ('L''estimateur de E(X^4) calculé est %.15f.\n', moyenne);
% On rappelle le nombre de simulations effectuées, qui seront utiles pour
% la mise en commun. Noter le code de format ‘%d’ pour afficher un entier.
fprintf ('Rappelons que nous avons procédé à %d simulations.\n', N);
% Il faut aussi préciser l'écart-type de f, qui normalement sera à peu près
% le même d'une simulation à l'autre (noter qu'il est inutile de connaitre
% celui-ci avec une grande précision).
fprintf ('L''écart-type de la v.a. dont on estime l''espérance est ')
fprintf ('environ %f.\n', sqrt (variance_f));
return
end
