% La fonction "MC_simple" évalue l'espérance de X^4, pour X suivant la loi
% P.
function MC_simple
% On désigne par "N_sim" le nombre de simulations.
N_sim = 5000000;
% "total" sera le total des simulations de la v.a. dont on cherche à
% évaluer l'espérance.
total = 0;
% Boucle de Monte-Carlo
for i = 1:N_sim
    % "X" est une réalisation de la loi P, indépendant à chaque passage
    % dans la boucle.
    X = simulation ();
    % "f" est une réalisation de X^4, càd. de la v.a. dont on cherche
    % l'espérance.
    f = X ^ 4;
    % On met à jour "total".
    total = total + f;
end
% "moyenne" est la moyenne empirique, qui est notre estimateur de
% Monte-Carlo.
moyenne = total / N_sim;
% On affiche le résultat. Le code de format ‘%f’ signifie que l'argument
% devra être affiché comme un nombre à virgule.
fprintf ('E(X^4) est estimé à %f.\n', moyenne);
% Le programme rend la main.
return
end
