% Ce programme répond à la question 5, en supposant la fonction
% "investigation_MC" déjà écrite.
function Q5
% "valeurs_Nsim" est la liste des différentes valeurs qu'il faura tester
% pour le nombre de simulations. Noter la syntaxe Matlab pour créer le
% vecteur-ligne des nombres de 1 à 10.
valeurs_Nsim = (1:10) * 1000000;
% "K" est le nombre de valeurs testées, qui n'est autre que le nombre de
% colonnes de "valeurs_Nsim". Noter la syntaxe Matlab pour déterminer le
% nombre de colonnes.
K = size (valeurs_Nsim, 2);
% On alloue la mémoire pour les différentes valeurs de m, de sigma et de t
% qui seront calculées, respectivement stockées dans les vecteurs-lignes
% "valeurs_m", "valeurs_sigma" et "valeurs_t".
valeurs_m = zeros (1, K);
valeurs_sigma = zeros (1, K);
valeurs_t = zeros (1, K);
% Dans cette boucle, on va lancer K fois la fonction "investigation_MC",
% pour chacun des nombres de simulations souhaités. "i" va correspondre à
% la case du vecteur "valeurs_N" qu'on est en train de considérer, et aussi
% aux cases de "valeurs_m", "valeurs_sigma" et "valeurs_t" qu'on va
% remplir.
for i = 1:K
    % Comme la fonction "investigation_MC" renvoie trois valeurs, il faut
    % utiliser la syntaxe Matlab qui dit explicitement qu'on veut récupérer
    % les trois valeurs.
    [m, sigma, t] = investigation_MC (valeurs_Nsim(i));
    % On remplit les cases idoines de "valeurs_m" etc.
    valeurs_m(i) = m;
    valeurs_sigma(i) = sigma;
    valeurs_t(i) = t;
end
% On crée une nouvelle figure, destinée à montrer t en fonction de N.
figure;
% Titre de la figure.
title ('t (en s) en fonction de N');
% On trace valeurs_t contre valeurs_N, sans relier les points (d'où le
% troisième argument « '+' »). Notez qu'ici il est essentiel que la i-ième
% case de "valeurs_t" corresponde à la i-ième case de "valeurs_Nsim".
plot (valeurs_Nsim, valeurs_t, '+');
% Petite astuce pour forcer le coin bas gauche du graphique à être le point
% de coordonnées (0,0). Pour ceux que la technique de Matlab intéresse,
% lors du "plot" précédent, Matlab a calculé automatiquement les valeurs
% extrêmes des axes du graphique. Je récupère les valeurs extrêmes des
% abscisses par la commande "xlim", et je stocke celles_ci dans "xlim_".
% Puis, toujours par la commande "xlim" (mais avec une autre syntaxe
% correspondant à un autre fonctionnement), j'impose que les extrêmités de
% l'axe des abscisses soient respectivement 0 et la valeur du maximum
% précédemment récupérée. Ensuite, on fait la même chose pour l'axe des y.
xlim_ = xlim; xlim ([0, xlim_(2)]); ylim_ = ylim; ylim ([0, ylim_(2)]);
% Nouvelle figure, pour montrer m en fonction de t.
figure;
title ('m en fonction de t (en s)');
plot (valeurs_t, valeurs_m, '+');
xlim_ = xlim; xlim ([0, xlim_(2)]); ylim_ = ylim; ylim ([0, ylim_(2)]);
% Nouvelle figure, pour montrer sigma^-2 en fonction de t (en ayant mis
% sigma à la puissance -2, on est censé observer à peu près une droite
% passant par l'origine).
figure;
title ('sigma^{-2} en fonction de t (en s)');
plot (valeurs_t, valeurs_sigma .^ -2, '+');
xlim_ = xlim; xlim ([0, xlim_(2)]); ylim_ = ylim; ylim ([0, ylim_(2)]);
return
end
