% La fonction "investigation_MC" prend en argument un nombre "N" de
% simulations requis, et renvoie respectivement l'estimateur "moyenne" de
% Monte-Carlo, l'écart-type (estimé) ectype_estimateur de cet estimateur,
% et le temps "t" pris par le calcul, lorsqu'on fait les calculs de la
% fonction "MC_IC".
function [moyenne, ectype_estimateur, t] = investigation_MC (N)
% On lance le chronomètre.
tic;
total = 0;
total_carres = 0;
for i = 1:N
    x = simulation ();
    f = x ^ 4;
    total = total + f;
    total_carres = total_carres + f * f;
end
moyenne = total / N;
moyenne_carres = total_carres / N;
variance_f = moyenne_carres - moyenne * moyenne;
ectype_estimateur = sqrt (variance_f / N);
% On arrête le chronomètre et on enregistre le temps écoulé (en secondes)
% dans "t".
t = toc;
return
end
