% La fonction "MC_brelan" évalue par la méthode de Monte-Carlo la
% probabilité d'obtenir un brelan pour un joueur de poker n'ayant que cet
% objectif. On prend en argument le nombre "N_sim" de simunations
% demandées. La fonction ne renvoie rien, se contentant d'afficher les
% résultats.
function MC_brelan (N_sim)
% "succes" compte le nombre de simulations qui ont conduit à un succès.
% Noter que dans ce cas où on estime une probabilité, càd. l'espérance
% d'une indicatrice, le nombre de succès correspond à la fois a la somme et
% la somme des carrés.
succes = 0;
for i = 1:N_sim
    % Dans la ligne suivante, on utilise la conversion implicite « false=0,
    % true=1 ».
    succes = succes + brelan ();
end
% "frequence" est la fréquence empirique des succès.
frequence = succes / N_sim;
% Ici la variance (estimée) se déduit directement de la valeur frequence.
variance_f = frequence * (1 - frequence);
ectype_estimateur = sqrt (variance_f / N_sim);
fprintf ('À 5 %% de risque d''erreur près, ')
fprintf ('la probabilité d''obtenir un brelan vaut ');
% Notez la syntaxe de Matlab pour couper une longue ligne.
fprintf ('%f ± %f.\n', frequence, ...
    sqrt (2) * erfinv (.95) * ectype_estimateur);
return
end
