% La fonction "simuler_Q" simule un vecteur-ligne "x" dans R^6 distribué selon la loi Q.
function x = simuler_Q
% On alloue la mémoire pour "x".
x = zeros (1, 6);
% On remarque que, d'après l'écriture de la densité de Q, les six coordonnéesde x seront indépendantes.
for i = 1:6
% Par symétrie de la densité de la loi de chaque coordonnée, on peut simuler celle-ci comme le produit d'un signe aléatoire uniforme "signe" par une variable positive "vabs" de densité sur R_+ proportionnelle à e^(-4x), indépendante du signe. Soit on reconnait en cette variable une loi exponentielle de taux 4 qu'on sait simuler directement, soit on utilise la méthode de la fonction de répartition (complémentaire en l'occurrence), ce qui est un exercice sans difficulté que je vous laisse faire.
vabs = -log (rand ()) / 4;
% Simulation du signe.
if rand < 1/2
signe = +1;
else
signe = -1;
end
x(i) = signe * vabs;
end
return
end
