% La fonction Q4 fait essentiellement la même chose que la fonction Q1,
% mais en utilisant la loi d'échantillonnage Q.
function Q4 (N)
% On appelle "Z" la valeur calculée à la question 3.
Z = 1/64;
total = 0;
total_carres = 0;
tic;
for i = 1:N
    % Cette fois-ci x est simulée en utilisant "simuler_Q".
    x = simuler_Q ();
    indicatrice = x * x' <= 1;
    % Attention, cette fois-ci ce n'est pas directement l'indicatrice qui
    % nous intéresse, mais son quotient par la densité de Q, quotient
    % appelé f. (En fait, c'était déjà le cas en substance quand on
    % échantillonnait uniformément sur un pavé ; à ceci près que, la
    % densité étant uniforme, il était plus pratique de faire la division à
    % la fin [ce qui revenait à multiplier par le volume de la boule] ; ici
    % cette astuce n'est pas possible). On calcule d'abord la densité.
    densite = exp (-4 * sum (abs (x))) / Z;
    f = indicatrice / densite;
    total = total + f;
    total_carres = total_carres + f * f;
end;
t = toc;
vol_boule = total / N;
ect_volboule = sqrt (total_carres / N - vol_boule * vol_boule) / sqrt (N);
fprintf ('J''estime le volume de la boule à %f ± %f ', ...
    vol_boule, 1.65 * ect_volboule);
fprintf ('(risque: 10 %%).\n');
fprintf ('L''efficacité du calcul ');
fprintf ('(ratio de sigma^-2 par le temps de calcul) est ici %f.\n', ...
    ect_volboule ^ -2 / t);
end
